## ros-iron-fuse-constraints 1.0.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(fuse_constraints)

# Default to C++17
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 17)
  set(CXX_STANDARD_REQUIRED YES)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_package(ament_cmake_ros REQUIRED)
find_package(fuse_core REQUIRED)
find_package(fuse_graphs REQUIRED)
find_package(fuse_variables REQUIRED)
find_package(geometry_msgs REQUIRED)
find_package(pluginlib REQUIRED)
find_package(rclcpp REQUIRED)

find_package(Ceres REQUIRED)
find_package(Eigen3 REQUIRED)
find_package(glog REQUIRED)

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR}/cmake)
include(suitesparse-extras.cmake)

###########
## Build ##
###########

# fuse_constraints library
add_library(${PROJECT_NAME}
  src/absolute_constraint.cpp
  src/absolute_orientation_3d_stamped_constraint.cpp
  src/absolute_orientation_3d_stamped_euler_constraint.cpp
  src/absolute_pose_2d_stamped_constraint.cpp
  src/absolute_pose_3d_stamped_constraint.cpp
  src/marginal_constraint.cpp
  src/marginal_cost_function.cpp
  src/marginalize_variables.cpp
  src/normal_delta.cpp
  src/normal_delta_orientation_2d.cpp
  src/normal_delta_pose_2d.cpp
  src/normal_prior_orientation_2d.cpp
  src/normal_prior_pose_2d.cpp
  src/relative_constraint.cpp
  src/relative_orientation_3d_stamped_constraint.cpp
  src/relative_pose_2d_stamped_constraint.cpp
  src/relative_pose_3d_stamped_constraint.cpp
  src/uuid_ordering.cpp
  src/variable_constraints.cpp
)
target_include_directories(${PROJECT_NAME} PUBLIC
  "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
  "$<INSTALL_INTERFACE:include/${PROJECT_NAME}>"
)
target_link_libraries(${PROJECT_NAME} PUBLIC
  Boost::serialization
  Ceres::ceres
  Eigen3::Eigen
  fuse_core::fuse_core
  fuse_graphs::fuse_graphs
  fuse_variables::fuse_variables
  ${geometry_msgs_TARGETS}
  pluginlib::pluginlib
  rclcpp::rclcpp
)
target_link_libraries(${PROJECT_NAME} PRIVATE
  ${SUITESPARSE_LIBRARIES}
)
target_include_directories(${PROJECT_NAME} PRIVATE
  ${SUITESPARSE_INCLUDE_DIRS}
)

#############
## Testing ##
#############

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()

  add_subdirectory(test)
  add_subdirectory(benchmark)
endif()

#############
## Install ##
#############

install(TARGETS ${PROJECT_NAME} EXPORT ${PROJECT_NAME}-export
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

install(DIRECTORY include/
  DESTINATION include/${PROJECT_NAME}
)

install(
  DIRECTORY cmake
  DESTINATION share/${PROJECT_NAME}
)

pluginlib_export_plugin_description_file(fuse_core fuse_plugins.xml)

ament_export_targets(${PROJECT_NAME}-export HAS_LIBRARY_TARGET)
ament_export_dependencies(
  ament_cmake_ros
  fuse_core
  fuse_graphs
  fuse_variables
  geometry_msgs
  pluginlib
  rclcpp

  Ceres
  Eigen3
  glog
)

ament_package(CONFIG_EXTRAS suitesparse-extras.cmake)

=== debian/changelog ===
ros-iron-fuse-constraints (1.0.1-3jammy) jammy; urgency=high



 -- Stephen Williams <swilliams@locusrobotics.com>  Thu, 02 Mar 2023 16:00:00 -0000

ros-iron-fuse-constraints (1.0.0-3jammy) jammy; urgency=high

  * Use rclcpp::Clock::wait_until_started (#303 <https://github.com/locusrobotics/fuse/issues/303>)
  * fuse -> ROS 2 : Doc Generation (#278 <https://github.com/locusrobotics/fuse/issues/278>)
    * Port doc generation and fix package.xml for linting
    * Fix small bugs in package.xml
    * Use default rosdoc2 settings
    * Use default rosdoc2 settings
    * Update fuse_doc for rosdoc2
    ---------
    Co-authored-by: Shane Loretz <mailto:sloretz@google.com>
  * fuse -> ROS 2 fuse_publishers: Port fuse_publishers (#299 <https://github.com/locusrobotics/fuse/issues/299>)
    Co-authored-by: Shane Loretz <mailto:shane.loretz@gmail.com>
  * ROS 2 port of fuse_viz (#301 <https://github.com/locusrobotics/fuse/issues/301>)
    * Initial attempt at porting fuse_viz
    * Make sure suitesparse can be found downstream
    * Plugin library names can't have lib/ prefix
    * Plugin library names can't have lib/ prefix
    * Add lint tests (they currently fail)
  * fuse -> ROS 2 fuse_constraints : Linting (#298 <https://github.com/locusrobotics/fuse/issues/298>)
  * fuse -> ROS 2 fuse_constraints: Port fuse_constraints (#290 <https://github.com/locusrobotics/fuse/issues/290>)
    Co-authored-by: Shane Loretz <mailto:sloretz@osrfoundation.org>
  * fuse -> ROS 2 fuse_graphs: Linting (#297 <https://github.com/locusrobotics/fuse/issues/297>)
  * fuse -> ROS 2 fuse_variables: Linting (#296 <https://github.com/locusrobotics/fuse/issues/296>)
    * Migrate to .hpp files
    * Create redirection headers
    * Make xmllint and uncrustify happy
    * Wrap most comment lines
    * Satisfy cpplint
  * fuse -> ROS 2 fuse_core: Linting (#292 <https://github.com/locusrobotics/fuse/issues/292>)
  * fuse -> ROS 2 fuse_core : Parameters and Tests (#286 <https://github.com/locusrobotics/fuse/issues/286>)
    Co-authored-by: Shane Loretz <mailto:sloretz@osrfoundation.org>
    Co-authored-by: Ivor Wanders <mailto:ivor@iwanders.net>
  * fuse -> ROS 2 : Port Time (#283 <https://github.com/locusrobotics/fuse/issues/283>)
  * Fuse -> ROS 2 fuse_core: Partial port of fuse_core (#281 <https://github.com/locusrobotics/fuse/issues/281>)
    Co-authored-by: Brett Downing
  * fuse -> ROS 2: Clean up macro usage warnings (#280 <https://github.com/locusrobotics/fuse/issues/280>)
  * fuse -> ROS 2 fuse_msgs : Port package and ignore unported packages for now (#277 <https://github.com/locusrobotics/fuse/issues/277>)
    Co-authored-by: Tom Moore <mailto:tmoore@locusrobotics.com>
  * [RST-4186] Fix fuse macro names (#263 <https://github.com/locusrobotics/fuse/issues/263>)
    * Namespace all macros with the FUSE_ prefix. Mark original macros as deprecated.
    * Update all fuse objects to use the new macro names
  * [RST-4390] Allow variables to be held constant during optimization (#243 <https://github.com/locusrobotics/fuse/issues/243>)
    * Add support for holding variables constant
    * Create a 'fixed' landmark
    * Added initial support for marginalizing constant variables
  * Adding doxygen to all packages (#241 <https://github.com/locusrobotics/fuse/issues/241>)
  * Contributors: Shane Loretz, Stephen Williams, Tom Moore, methylDragon

 -- Stephen Williams <swilliams@locusrobotics.com>  Thu, 02 Mar 2023 16:00:00 -0000

ros-iron-fuse-constraints (0.4.2-3jammy) jammy; urgency=high

  * Adding roslint dependency to fuse_viz (#231 <https://github.com/locusrobotics/fuse/issues/231>)
    * Adding roslint dependency to fuse_viz
    * Silence CMP0048 warnings
  * Contributors: Tom Moore

 -- Stephen Williams <swilliams@locusrobotics.com>  Mon, 19 Jul 2021 16:00:00 -0000

ros-iron-fuse-constraints (0.4.1-3jammy) jammy; urgency=high

  * Use analytic relative pose 2d cost function (#193 <https://github.com/locusrobotics/fuse/issues/193>)
    * Use analytic relative pose 2d cost function
    * Add analytic NormalDeltaPose2D cost function
    * Use analytic NormalDeltaPose2D cost function in
    RelativePose2DStampedConstraint
    * Test NormalDeltaPose2D jacobians are correct, comparing against
    NormalDeltaPose2DCostFunctor using automatic differentiation
    * Benchmark NormalDeltaPose2D vs NormalDeltaPose2DCostFunctor using
    automatic differentiation for 1, 2 and 3 residuals. The latency
    speedup is approximately 1.35, 1.49 and 1.55, respectively.
  * Use analytic absolute pose 2d cost function (#192 <https://github.com/locusrobotics/fuse/issues/192>)
    * Add analytic NormalPriorPose2D cost function
    * Use analytic NormalPriorPose2D cost function in
    AbsolutePose2DStampedConstraint
    * Test NormalPriorPose2D jacobians are correct, comparing against
    NormalPriorPose2DCostFunctor using automatic differentiation
    * Benchmark NormalPriorPose2D vs NormalPriorPose2DCostFunctor using
    automatic differentiation for 1, 2 and 3 residuals. The latency
    speedup is approximately 2.36, 2.76 and 3.44, respectively.
  * Fix roslint 0.12.0 (#186 <https://github.com/locusrobotics/fuse/issues/186>)
    * Fix roslint 0.12.0 include_what_you_use warnings
    Mostly for:
    * std::move -> #include <utility>
    * std::make_shared and similar -> #include <memory>
    * Remove static string variable not permitted by roslint 0.12.0, using a test fixture where needed.
  * Fix Unicycle2DIgnition set_pose (#154 <https://github.com/locusrobotics/fuse/issues/154>)
    * Initialize StateHistoryElement::velocity_yaw
    * Process ignition transactions individually
    * Call motion model generator with last stamp
    * Skip optimization cycle if transaction is empty
  * Fix compute elimination order with orphan variables (#136 <https://github.com/locusrobotics/fuse/issues/136>)
    * Test computeEliminationOrder with orphan variables
    * Fix computeEliminationOrder with orphan variables


=== debian/control ===
Source: ros-iron-fuse-constraints
Section: misc
Priority: optional
Maintainer: Stephen Williams <swilliams@locusrobotics.com>
Build-Depends: debhelper (>= 9.0.0), libbenchmark-dev <!nocheck>, libceres-dev, libeigen3-dev, libsuitesparse-dev, ros-iron-ament-cmake-gtest <!nocheck>, ros-iron-ament-cmake-ros, ros-iron-ament-lint-auto <!nocheck>, ros-iron-ament-lint-common <!nocheck>, ros-iron-fuse-core, ros-iron-fuse-graphs, ros-iron-fuse-variables, ros-iron-geometry-msgs, ros-iron-pluginlib, ros-iron-rclcpp, ros-iron-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-iron-fuse-constraints
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libceres-dev, libeigen3-dev, libsuitesparse-dev, ros-iron-fuse-core, ros-iron-fuse-graphs, ros-iron-fuse-variables, ros-iron-geometry-msgs, ros-iron-pluginlib, ros-iron-rclcpp, ros-iron-ros-workspace
Description: The fuse_constraints package provides a set of commonly used constraint types, such as direct measurements on \ state variables (absolute constraints) or measurements of the state changes (relative constraints).

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/iron/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/iron" \
		-DAMENT_PREFIX_PATH="/opt/ros/iron" \
		-DCMAKE_PREFIX_PATH="/opt/ros/iron" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-iron-fuse-constraints//opt/ros/iron/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_install
